
#include "descriptor/descriptor.h"

int main(void) {

	ITEM	glass,ceramic,brown,yellow,blu,nero,nero_satinato,metal_black,bianco,nero2;
	ITEM	muro_col,pav_col,zanne_col;
	ITEM	scene;
	ITEM	stanza,tavolo,finestra,mammy,lampada,sedia,imac,tastiera,mouse,paretebucata;
	ITEM	pavimento,lastra,lastra2,occhio1,occhio2,zanna1,zanna2,lampadina1,lampadina2,
			lampadina3,lampadina4,lampadina5;
	ITEM	schienale,pezzo_sedia,schermo,vetro,manopola,poggia_manopola;

	char * tex_marmo = "textures/marmo2.hr";
	char * tex_wood = "textures/wood.hr";
	char * tex_fur = "textures/fur2.hr";
	char * tex_cielo = "textures/cielo.hr";

//--------------------------------------------------------

	set_background(0.9,0.9,0.9,TRUE);
	set_ambient_light(1,1,1,0.7);
	create_point_light(-11.2,4.6,5.5,1,1,1,1.0,15, "light1");
	create_point_light(4.3,-9.8,9.0,1,1,1,1.0,27, "light2");

//--------------------------------------------------------

/*** ATTRIBUTE muro_col ***/
	muro_col = create_attribute("muro_col");
	set_color(muro_col,1,1,0.95,1,0.79);

/*** ATTRIBUTE pav_col ***/
	pav_col = create_attribute("pav_col");
	set_color(pav_col,1,1,0.95,0.4,0.4);
	set_reflectivity(pav_col,0.24,1);
	set_transparency(pav_col,0,0,0,3.948);

/*** ATTRIBUTE zanne_col ***/
	zanne_col = create_attribute("zanne_col");
	set_color(zanne_col,1,1,0.80,1,0.79);
	set_reflectivity(zanne_col,0.01,1);
	set_transparency(zanne_col,0,0,0,5);

/*** ATTRIBUTE glass ***/
	glass = create_attribute("glass");
	set_color(glass,0.68,0.86,1,0.5,0.5);
	set_reflectivity(glass,0.24,2);
	set_transparency(glass,0.87,0.68,1,1.2);

/*** ATTRIBUTE ceramic ***/
	ceramic = create_attribute("ceramic");
	set_color(ceramic,0.89,0.76,0.65,0.1,0.8);
	set_reflectivity(ceramic,0.2,128);

/*** ATTRIBUTE brown ***/
	brown = create_attribute("brown");
	set_color(brown,0.93,0.23,0.03,0.5,0.716);
	set_transparency(pav_col,0,0,0,10);


/*** ATTRIBUTE yellow ***/
	yellow = create_attribute("yellow");
	set_color(yellow,1,1,0,0.2,0.8);
	set_reflectivity(yellow,0.3,10);

/*** ATTRIBUTE blu ***/
	blu = create_attribute("blu");
	set_color(blu,0,0,1,0.5,0.5);
	set_reflectivity(blu,0.3,10);

/*** ATTRIBUTE nero ***/
	nero = create_attribute("nero");
	set_color(nero,0,0,0,0.1,0.8);
	set_reflectivity(nero,0.4,1);

/*** ATTRIBUTE nero2 ***/
	nero2 = create_attribute("nero2");
	set_color(nero2,0,0,0,0.7,0.8);
	set_reflectivity(nero2,0.15,1);

/*** ATTRIBUTE bianco ***/
	bianco = create_attribute("bianco");
	set_color(bianco,1,1,1,0.7,0.79);
	set_reflectivity(bianco,0.15,1);

/*** ATTRIBUTE nero satinato***/
	nero_satinato = create_attribute("nero_satinato");
	set_color(nero_satinato,0.3,0.3,0.3,0.1,0.8);

/*** ATTRIBUTE metal_black ***/
	metal_black = create_attribute("metal_black");
	set_color(metal_black,0.0,0.0,0.0,0.8,0.8);
	set_reflectivity(metal_black,0.05,2);
	set_transparency(metal_black,0.0,0.0,0.0,6);

//--------------------------------------------------------

/*** STANZA ***/
	stanza = read_nurbs("par1.db");
	set_attribute(stanza,muro_col);
	set_scale(stanza,10,10,10);

   /***  pavimento ***/
	pavimento = read_nurbs("pav.db");

	set_scale(pavimento, 8.0, 8.0, 1);
	set_translate(pavimento,0.5,0.5,1.5);
	set_domain_texture(pavimento, pav_col, tex_marmo, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);
	set_translate(pavimento,-0.5,-0.5,-1.5);
	set_scale(pavimento, 1.0/8.0, 1.0/8.0, 1);
	set_scale(pavimento,10,10,10);

/*** TAVOLO ***/
	tavolo = read_obj("tavolo2.obj", "tavolo");
	set_attribute(tavolo,glass);

	set_scale(tavolo, 8.0, 8.0, 1);
	set_translate(tavolo,0.5,0.5,1.5);
	set_domain_texture(tavolo, muro_col, tex_wood, 0.5, 0, 0.5, 0, 1, 0.6, 0.8);
	set_translate(tavolo,-0.5,-0.5,-1.5);
	set_scale(tavolo, 1.0/8.0, 1.0/8.0, 1);
	set_translate(tavolo,-17,17,2);
	set_scale(tavolo,0.3,0.3,0.3);

   /***  lastra legno ***/
	lastra2 = read_nurbs("sup_tav2.db");

	set_scale(lastra2, 2.0, 2.0, 1);
	set_translate(lastra2,0.5,0.5,1.5);
	set_projection_texture(lastra2,muro_col,tex_wood,1,1,0.6,0.5);
	set_translate(lastra2,-0.5,-0.5,-1.5);
	set_scale(lastra2, 1.0/2.0, 1.0/2.0, 1);
	set_translate(lastra2,-17,17,2);
	set_scale(lastra2,0.3,0.3,0.3);

   /***  lastra vetro ***/
	lastra = read_nurbs("sup_tav1.db");
	set_attribute(lastra,glass);
	set_translate(lastra,-17,17,1.999);
	set_scale(lastra,0.3,0.3,0.3);

/*** FINESTRA ***/
	finestra = read_obj("finestra2.obj", "finestra");

	set_scale(finestra, 8.0, 8.0, 1);
	set_translate(finestra,0.5,0.5,1.5);
	set_domain_texture(finestra, muro_col, tex_wood, 0.5, 0, 0.5, 0, 1, 0.6, 0.8);
	set_translate(finestra,-0.5,-0.5,-1.5);
	set_scale(finestra, 1.0/8.0, 1.0/8.0, 1);

	set_translate(finestra,-50,-45,-99.5);
	set_scale(finestra,0.1,0.1,0.1);
	set_y_rotate(finestra,90,1);
	set_x_rotate(finestra,-90,1);

	paretebucata = read_obj("parete_bucata.obj", "buco");
	set_attribute(paretebucata,muro_col);
	set_translate(paretebucata,-50,-45,-99.5);
	set_scale(paretebucata,0.1,0.1,0.1);
	set_y_rotate(paretebucata,90,1);
	set_x_rotate(paretebucata,-90,1);

  /***  maniglia ***/
	manopola = read_nurbs("manopola.db");
	set_attribute(manopola,nero_satinato);
	set_translate(manopola,-50,-45,-99.5);
	set_scale(manopola,0.1,0.1,0.1);
	set_y_rotate(manopola,90,1);
	set_x_rotate(manopola,-90,1);

	poggia_manopola = read_nurbs("poggia_manopola.db");
	set_attribute(poggia_manopola,nero_satinato);
	set_translate(poggia_manopola,-50,-45,-99.5);
	set_scale(poggia_manopola,0.1,0.1,0.1);
	set_y_rotate(poggia_manopola,90,1);
	set_x_rotate(poggia_manopola,-90,1);

  /***  vetro ***/
	vetro = read_nurbs("vetro.db");

 	set_x_rotate(vetro,90,1);
 	set_scale(vetro, 0.04, 0.04, 0.04);
 	set_translate(vetro,0.6,0.3,0.5);
  	set_projection_texture(vetro,glass,tex_cielo,1,1,0.4,0.5);
	set_translate(vetro,-0.6,-0.3,-0.5);
	set_scale(vetro, 1.0/0.04, 1.0/0.04, 1.0/0.04);
	set_x_rotate(vetro,-90,1);

	set_translate(vetro,-50,-45,-99.5);
	set_scale(vetro,0.1,0.1,0.1);
	set_y_rotate(vetro,90,1);
	set_x_rotate(vetro,-90,1);

/*** MAMMOUTH ***/
	mammy = read_obj("mammouth2.obj", "mammy");
	set_attribute(mammy,brown);
 	set_translate(mammy,11.5,5,7);
 	set_scale(mammy,0.8,0.8,0.8);
 	set_z_rotate(mammy,90,1);

  /***  occhi ***/
	occhio1 = read_nurbs("occhio.db");
	set_attribute(occhio1,nero);
	set_translate(occhio1,11.5,5,7);
 	set_scale(occhio1,0.8,0.8,0.8);
 	set_z_rotate(occhio1,90,1);

	occhio2 = read_nurbs("occhio3.db");
	set_attribute(occhio2,nero);
	set_translate(occhio2,11.5,5,7);
 	set_scale(occhio2,0.8,0.8,0.8);
 	set_z_rotate(occhio2,90,1);

  /***  zanne ***/
	zanna1 = read_nurbs("zanna_pos.db");
	set_attribute(zanna1,zanne_col);
	set_translate(zanna1,11.5,5,7);
 	set_scale(zanna1,0.8,0.8,0.8);
 	set_z_rotate(zanna1,90,1);

	zanna2 = read_nurbs("zanna_pos2.db");
	set_attribute(zanna2,zanne_col);
	set_translate(zanna2,11.5,5,7);
 	set_scale(zanna2,0.8,0.8,0.8);
 	set_z_rotate(zanna2,90,1);

/*** LAMPADA ***/
	lampada = read_obj("lampada2.obj", "lampada");
	set_attribute(lampada,nero_satinato);
  	set_translate(lampada,-9.5,0,0);
  	set_scale(lampada,1.25,1.25,1.25);
  	set_z_rotate(lampada,-45,1);

  /***  lampade ***/
	lampadina1 = read_nurbs("lampadina1.db");
	set_attribute(lampadina1,glass);
  	set_translate(lampadina1,-9.5,0,0);
  	set_scale(lampadina1,1.25,1.25,1.25);
  	set_z_rotate(lampadina1,-45,1);

	lampadina2 = read_nurbs("lampadina2.db");
	set_attribute(lampadina2,glass);
  	set_translate(lampadina2,-9.5,0,0);
  	set_scale(lampadina2,1.25,1.25,1.25);
  	set_z_rotate(lampadina2,-45,1);

	lampadina3 = read_nurbs("lampadina3.db");
	set_attribute(lampadina3,glass);
  	set_translate(lampadina3,-9.5,0,0);
  	set_scale(lampadina3,1.25,1.25,1.25);
  	set_z_rotate(lampadina3,-45,1);

	lampadina4 = read_nurbs("lampadina4.db");
	set_attribute(lampadina4,glass);
  	set_translate(lampadina4,-9.5,0,0);
  	set_scale(lampadina4,1.25,1.25,1.25);
  	set_z_rotate(lampadina4,-45,1);

	lampadina5 = read_nurbs("lampadina5.db");
	set_attribute(lampadina5,glass);
  	set_translate(lampadina5,-9.5,0,0);
  	set_scale(lampadina5,1.25,1.25,1.25);
  	set_z_rotate(lampadina5,-45,1);

/*** SEDIA ***/
	sedia = read_obj("sedia2.obj", "sedia");
	set_attribute(sedia,nero_satinato);
  	set_translate(sedia,-8,-3.5,1.5);
 	set_scale(sedia,0.7,0.7,0.7);
  	set_z_rotate(sedia,-45,1);

  /***  schienale e pezzo sotto ***/
	schienale = read_nurbs("schienale.db");

	set_scale(schienale, 2.0, 2.0, 1);
	set_translate(schienale,0.5,0.5,1.5);
	set_projection_texture(schienale,muro_col,tex_wood,1,1,0.6,0.5);
	set_translate(schienale,-0.5,-0.5,-1.5);
	set_scale(schienale, 1.0/2.0, 1.0/2.0, 1);

  	set_translate(schienale,-8,-3.5,1.5);
 	set_scale(schienale,0.7,0.7,0.7);
  	set_z_rotate(schienale,-45,1);

	pezzo_sedia = read_nurbs("pezzo_sedia.db");

	set_scale(pezzo_sedia, 2.0, 2.0, 1);
	set_translate(pezzo_sedia,0.5,0.5,1.5);
	set_projection_texture(pezzo_sedia,muro_col,tex_wood,1,1,0.6,0.5);
	set_translate(pezzo_sedia,-0.5,-0.5,-1.5);
	set_scale(pezzo_sedia, 1.0/2.0, 1.0/2.0, 1);

  	set_translate(pezzo_sedia,-8,-3.5,1.5);
 	set_scale(pezzo_sedia,0.7,0.7,0.7);
  	set_z_rotate(pezzo_sedia,-45,1);

/*** iMAC ***/
	imac = read_obj("iMac2.obj", "iMac");
	set_attribute(imac,bianco);
  	set_translate(imac,-22,8,9.1);
 	set_scale(imac,0.3,0.3,0.3);
  	set_z_rotate(imac,-30,1);

  /*** schermo ***/
	schermo = read_nurbs("schermo.db");
	set_attribute(schermo,nero2);
  	set_translate(schermo,-22,8,9.1);
 	set_scale(schermo,0.3,0.3,0.3);
  	set_z_rotate(schermo,-30,1);

/*** TASTIERA ***/
	tastiera = read_nurbs("tastiera.db");
	set_attribute(tastiera,bianco);
	set_scale(tastiera,0.3,0.3,0.3);
	set_translate(tastiera,-6.2,4.6,2.3);

/*** MOUSE ***/
	mouse = read_nurbs("mouse.db");
	set_attribute(mouse,bianco);
 	set_scale(mouse,0.3,0.3,0.3);
 	set_translate(mouse,-4.5,4.3,2.15);

//--------------------------------------------------------

	scene = create_list(stanza, "scene");
	scene = insert_in_list(scene,pavimento);
	scene = insert_in_list(scene,tavolo);
 	scene = insert_in_list(scene,lastra);
	scene = insert_in_list(scene,lastra2);
	scene = insert_in_list(scene,finestra);
	scene = insert_in_list(scene,manopola);
	scene = insert_in_list(scene,poggia_manopola);
	scene = insert_in_list(scene,mammy);
	scene = insert_in_list(scene,occhio1);
	scene = insert_in_list(scene,occhio2);
	scene = insert_in_list(scene,zanna1);
	scene = insert_in_list(scene,zanna2);
 	scene = insert_in_list(scene,lampada);
	scene = insert_in_list(scene,lampadina1);
	scene = insert_in_list(scene,lampadina2);
	scene = insert_in_list(scene,lampadina3);
	scene = insert_in_list(scene,lampadina4);
	scene = insert_in_list(scene,lampadina5);
  	scene = insert_in_list(scene,sedia);
	scene = insert_in_list(scene,schienale);
	scene = insert_in_list(scene,pezzo_sedia);
 	scene = insert_in_list(scene,imac);
	scene = insert_in_list(scene,schermo);
 	scene = insert_in_list(scene,tastiera);
 	scene = insert_in_list(scene,mouse);
	scene = insert_in_list(scene,paretebucata);

	save_scene("mammouth.md","scene_mammouth",scene);
	return(0);
}
